Sound = function( src, loop ) {

	var 
		_fading = false,
		_audio = document.createElement( 'audio' ),
		_tween = new Tween( function ( v ) { 
			_audio.volume = v; 
		} );

		if( _audio.canPlayType( 'audio/ogg; codecs="vorbis"' ) ) {
			_audio.src = src + '.ogg';
		} else {
			_audio.src = src + '.mp3';
		}
		_audio.loop = loop;
		_audio.volume = 0;

	function _play( v ) {

		_fading = true;
		if( v == undefined ) v = 1;
		_tween.to( v, 1000 );
		_tween.start( _audio.volume, function() { _fading = false } );

		_audio.currentTime = 0;
		_audio.play();

	}

	function _stop() {

		_fading = true;
		_tween.to( 0, 1000 );
		_tween.start( _audio.volume, function() { _fading = false; _audio.pause(); } );

	}

	function _volume( v ) {

		if( !_fading ) _audio.volume = v;

	}

	return {

		play: _play,
		stop: _stop,
		volume: _volume

	}
	
}