Tween = function( updateCallback ) {

	var 
		oValue = 0,
		time = 0, 
		toValue = 0,
		startTime,
		_isRunning = false,
		onCompleteCallback;

	function start( value, c ) {

		_isRunning = true;
		onCompleteCallback = c;
		oValue = value;
		startTime = Date.now();
		update();

	}

	function update() {

		var t = Date.now();
		var e = t - startTime;
		var k = e / time;
		if( k > 1 ) k = 1;
		
		value = oValue + ( toValue - oValue ) * k * ( 2 - k );
		onUpdate( value );

		if( k < 1 ) setTimeout( update, 10 );
		else {
			_isRunning = false;
			if( onCompleteCallback ) onCompleteCallback();
		}

	}

	function to( v, t ) {

		time = t;
		toValue = v;

	}

	function onUpdate() {
		if( updateCallback ) updateCallback( value );
		else console.log( value );
	}

	return {

		start: start,
		to: to,
		onUpdate: onUpdate,
		running: _isRunning

	}
	
}